package net.sf.itcb.addons.monitoring.track.portlet;

import org.springframework.beans.factory.annotation.Required;

import net.sf.itcb.addons.monitoring.track.TransactionIdHolder;
import net.sf.itcb.addons.monitoring.track.appender.ItcbAppender;
import net.sf.itcb.addons.monitoring.track.bean.ItcbTrackBean;
import net.sf.itcb.common.portlet.vaadin.page.impl.PageMappingProcessorImpl;

public class TrackedPageMappingProcessorImpl extends PageMappingProcessorImpl{

	private static final long serialVersionUID = 1L;
	
	private ItcbAppender itcbAppender;
	
	@Required
	public void setItcbAppender(ItcbAppender itcbAppender) {
		this.itcbAppender = itcbAppender;
	}
	
	@Override
	public void displayPage(String refPage, ReloadOrder reload) {
		 long startTime = System.currentTimeMillis();
		 ItcbTrackBean itcbTrackBean = new ItcbTrackBean();
		 itcbTrackBean.setClassName(getClass().getName());
		 itcbTrackBean.setMethod("displayPage("+refPage+","+reload+")");
		 itcbTrackBean.setStartTime(startTime);
		 itcbTrackBean.setTransactionId(TransactionIdHolder.getTransactionId());
		 try {
			 super.displayPage(refPage, reload);
	    	
	    	itcbTrackBean.setTimeInMillis(System.currentTimeMillis() - startTime);
	    	itcbAppender.track(itcbTrackBean);
	     }
	     catch(RuntimeException t) {
	    	itcbTrackBean.setTimeInMillis(System.currentTimeMillis() - startTime);
		    itcbTrackBean.setException(t);
		    itcbAppender.track(itcbTrackBean);
	    	throw t;
	     }
	}
	
	
}
